import 'package:flutter/cupertino.dart';
import 'package:mobx/mobx.dart';
import 'package:sunny_dart/sunny_dart.dart';
import 'package:sunny_essentials/state.dart';

class Watcher extends StatefulWidget {
  final VoidCallback? watch;
  final WidgetBuilder? builder;
  final String? name;

  const Watcher({Key? key, this.builder, this.name, this.watch})
      : super(key: key);

  @override
  _WatcherState createState() => _WatcherState();
}

class _WatcherState extends BaseState<Watcher> with LoggingMixin {
  @override
  String get loggerName => "watcher.${widget.name}";

  @override
  Widget build(BuildContext context) {
    return widget.builder!(context);
  }

  @override
  void initState() {
    super.initState();

    disposers.add(reaction((_) => widget.watch!(), (dynamic _) {
      if (context.findRenderObject() != null) {
        log.info("Detected change.  Rebuilding");
        setState(() {});
      }
    }, delay: 300, name: widget.name));
  }
}
