import 'package:flutter/widgets.dart';

/// An "interface" that requires a Widget to provide its height
abstract class FixedHeight implements Widget {
  double? get maxHeight;
}

/// An "interface" that requires a Widget to provide its height
abstract class Expandable implements Widget {
  double get minExtent;

  double get maxExtent;

  double get extent;
}

/// An "interface" that requires a Widget to provide its width
abstract class FixedWidth implements Widget {
  double get maxWidth;
}

class FixedHeightContainer extends StatelessWidget implements FixedHeight {
  final double? maxHeight;
  final Widget? child;

  const FixedHeightContainer({Key? key, this.maxHeight, this.child}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: maxHeight,
      child: child,
    );
  }
}
