import 'dart:async';

import 'package:sunny_dart/sunny_get.dart';
import 'package:sunny_forms/media/media_content_type.dart';
import 'package:sunny_sdk_core/model/progress_tracker.dart';
import 'package:sunny_sdk_core/services/sunny.dart';

IMediaService get mediaService => sunny.get<IMediaService>();

abstract class IMediaService {
  ProgressTracker<Uri> uploadMedia(
      final dynamic file, MediaContentType contentType,
      {mediaType, String? mediaId, ProgressTracker<Uri>? progress});

  /// Gets a relative path to the picture
  FutureOr<String> getMediaPath(MediaContentType contentType, String mediaId,
      {mediaType});

  /// Gets an absolute URI to the picture
  FutureOr<Uri> getMediaUri(MediaContentType contentType, String mediaId,
      {mediaType});
}

extension MediaServiceHelpersExt on IMediaService {
  ProgressTracker<Uri> uploadImage(final dynamic file,
      {pictureType, String? pictureId, ProgressTracker<Uri>? progress}) {
    return uploadMedia(file, MediaContentType.image,
        mediaType: pictureType, mediaId: pictureId, progress: progress);
  }
}
