import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:sunny_dart/typedefs.dart';
import 'package:sunny_forms/widget_extensions.dart';

class ListViewBuilder {
  final List<WidgetBuilder> allItems = [];

  ListViewBuilder();

  ListViewBuilder add<T>({
    required Iterable<T> items,
    Getter<Widget>? header,
    WidgetValueBuilder<T>? builder,
    bool divide = false,
  }) {
    if (header != null && items.isNotEmpty) {
      allItems.add((_) => header());
    }
    items.forEach((item) {
      allItems.add((_) => builder!(_, item));
    });
    return this;
  }

  ListViewBuilder addWidget({
    Getter<Widget>? child,
    required bool addIf,
  }) {
    if (addIf) {
      allItems.add((_) => child!());
    }
    return this;
  }

  Widget build(ListView build(int count, IndexedWidgetBuilder builder)) {
    return build(allItems.length, (context, idx) => allItems[idx](context));
  }
}
