import 'package:flutter/widgets.dart';
import 'package:sunny_dart/json.dart';
import 'package:sunny_dart/sunny_dart.dart';
import 'package:sunny_forms/form_fields/range_control.dart';
import 'package:sunny_forms/meta/meta_property_handler.dart';
import 'package:sunny_forms/sunny_form_field.dart';
import 'package:sunny_sdk_core/mverse/definitions.dart';
import 'package:sunny_sdk_core/sunny_sdk_core.dart';
import 'package:sunny_service_stubs/models.dart';
import 'package:sunny_service_stubs/options.dart';

class RangePropertyHandler extends MetaPropertyHandler<IRange> {
  RangePropertyHandler();

  @override
  Iterable<Widget> renderProperty(
      BuildContext context,
      IMetaFormContext metaForm,
      HandledPaths paths,
      SunnyFormFieldState<IRange> state,
      {Key? key}) {
    // ignore: unused_local_variable
    final prop =
        paths.paths.values.firstOrNull ?? metaForm.schema.getByPath(paths.path);
    state.captureNestedPaths = true;
    return [
      RangeControl(
//        prefixIcon: widget.prefixIcon,
//        width: widget.width,

        basePath: paths.path,
        onError: (error) {
          state.error = error;
        },
        onChange: (range, source) {
          state.updateValue(range, source);
        },
        initialValue: state.value,
      ),
    ];
  }

  @override
  Iterable<HandledPaths> acceptProperties(
      JsonPath? basePath,
      IMSchemaDefinition definition,
      Map<JsonPath, IMSchemaProperty> available) {
    return available
        .filterEntries((k, v) => v.baseCode == Definitions.range.baseCode)
        .mapEntries((k, v) => HandledPaths.ofProperty(v, basePath!, this));
  }
}
