import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_platform_widgets/flutter_platform_widgets.dart';
import 'package:sunny_forms/sunny_colors.dart';

class PlatformChip extends PlatformWidgetBase<InputChip, InputChip> {
  final Widget? avatar;
  final VoidCallback? onDeleted;
  final Widget? deleteIcon;
  final Widget label;
  final Color? backgroundColor;
  final double? elevation;

  PlatformChip(
      {Key? key,
      this.avatar,
      required this.label,
      this.deleteIcon,
      this.elevation,
      this.onDeleted,
      this.backgroundColor})
      : super(key: key);

  @override
  InputChip createMaterialWidget(BuildContext context) {
    return InputChip(
      key: key,
      avatar: avatar,
      label: label,
      backgroundColor: backgroundColor,
      elevation: elevation,
      deleteIcon: deleteIcon,
      materialTapTargetSize: MaterialTapTargetSize.shrinkWrap,
      onDeleted: onDeleted,
    );
  }

  @override
  InputChip createCupertinoWidget(BuildContext context) {
    return InputChip(
      key: key,
      avatar: avatar,
      label: label,
      backgroundColor: backgroundColor,
      elevation: elevation,
      labelPadding: avatar == null
          ? EdgeInsets.only(left: 10, right: 10)
          : EdgeInsets.zero,
      deleteIcon: deleteIcon ?? Icon(CupertinoIcons.clear),
      pressElevation: 0,
      onPressed: () {},
      onDeleted: onDeleted,
      visualDensity: VisualDensity.compact,
      padding: EdgeInsets.all(0),
      materialTapTargetSize: MaterialTapTargetSize.shrinkWrap,
      shadowColor: SunnyColors.subTitleText,
      shape: RoundedRectangleBorder(
//          side: BorderSide(width: 1.0, color: SunnyColors.inputBorder),
          borderRadius: BorderRadius.circular(20)),
    );
  }
}
