import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_platform_widgets/flutter_platform_widgets.dart';

/// A cross-platform modal overlay
class PlatformPopupSurface extends PlatformWidgetBase {
  final Widget? child;

  PlatformPopupSurface({Key? key, this.child}) : super(key: key);

  @override
  Widget createMaterialWidget(BuildContext context) {
    return Material(
      elevation: 2,
      child: child,
    );
  }

  @override
  Widget createCupertinoWidget(BuildContext context) {
    return CupertinoPopupSurface(child: child, isSurfacePainted: true);
  }
}
