import 'package:flutter/widgets.dart';
import 'package:info_x/info_x.dart';

abstract class PlatformStatefulWidgetBase<I extends Widget, A extends Widget>
    extends StatefulWidget {
  PlatformStatefulWidgetBase({Key? key}) : super(key: key);

  @override
  State createState();
}

abstract class PlatformWidgetState<I extends Widget, A extends Widget,
    P extends PlatformStatefulWidgetBase<I, A>> extends State<P> {
  @override
  Widget build(BuildContext context) {
    if (infoX.isIOS) {
      return createCupertinoWidget(context);
    } else {
      return createMaterialWidget(context);
    }
  }

  P get platformWidget => widget;

  I createCupertinoWidget(BuildContext context);

  A createMaterialWidget(BuildContext context);
}
