// import 'dart:async';
//
// import 'package:flutter/foundation.dart';
// import 'package:flutter/widgets.dart';
// import 'package:sunny_dart/sunny_dart.dart';
// import 'package:sunny_sdk_core/sunny_sdk_core.dart';
//
// import 'observer_mixin.dart';
//
// /// A base class
// abstract class StateObserver<T extends StatefulWidget> extends State<T>
//     with ObserverMixin, LoggingMixin {
//   String stateId = uuid();
//   Object? pageError;
//
//   void safeState(VoidCallback callback) {
//     if (mounted) {
//       setState(callback);
//     }
//   }
//
//   FocusNode createFocusNode({String? debugLabel, bool watch = false}) {
//     var node = FocusNode(debugLabel: debugLabel);
//     disposers.add(node.dispose);
//
//     if (watch) {
//       node.addListener(() {
//         safeState(() {});
//       });
//     }
//     return node;
//   }
//
//   void watchFocusNode(FocusNode focusNode) {
//     var updateState = () => safeState(() {});
//     focusNode.addListener(updateState);
//     disposers.add(() {
//       focusNode.removeListener(updateState);
//     });
//   }
//
//   Future asyncState(AsyncCallback callback) async {
//     await callback.call();
//     safeState(() {});
//   }
//
//   Future trying(AsyncCallback fn) async {
//     try {
//       await fn();
//     } catch (e, stack) {
//       log.severe("Error in widget: $e", e, stack);
//       setState(() {
//         pageError = e;
//       });
//     }
//   }
//
//   void showKeyboard(BuildContext context) {}
//
//   Key childKey(String name) {
//     return Key("$stateId$name");
//   }
//
//   @override
//   @mustCallSuper
//   void dispose() {
//     disposeObservations();
//     super.dispose();
//   }
//
//   onObserve({name}) {
//     print("OBSERVED!");
//     setState(() {});
//   }
// }
//
// extension StateObserverStream<T> on StreamSubscription<T> {
//   void watch(HasDisposers obs) {
//     obs.registerDisposer(this.cancel);
//   }
// }
//
// extension StreamReader<T> on Stream<T> {
//   void watch(StateObserver obs) {
//     this.listen((_) {}, cancelOnError: false).watch(obs);
//   }
// }
