import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:sunny_dart/sunny_dart.dart';
import 'package:sunny_forms/shared/theme_helpers.dart';
import 'package:sunny_forms/standard_column.dart';
import 'package:sunny_forms/sunny_colors.dart';

class FakeFieldContainer extends StatelessWidget {
  final bool focused;
  final IconData? icon;
  final String? placeholder;
  final Widget? value;

  const FakeFieldContainer(
      {Key? key, this.focused = false, this.icon, this.placeholder, this.value})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    final style = value != null
        ? SunnyTextFieldStyles.inputText
        : SunnyTextFieldStyles.inputPlaceholder;
    return AnimatedContainer(
      padding: defaultInputPadding,
      decoration: BoxDecoration(
        border: Border(
          bottom: focused
              ? SunnyDeco.inputBorderFocused
              : SunnyDeco.inputBorderInactive,
        ),
      ),
      child: Container(
        child: row(
          [
            if (icon != null)
              AnimatedDefaultTextStyle(
                child: Icon(icon,
                    size: 20,
                    color: focused || value != null
                        ? sunnyColors.primaryColor
                        : sunnyColors.iconDisabled),
                style: focused
                    ? SunnyTextFieldStyles.inputText
                    : SunnyTextFieldStyles.inputPlaceholder,
                duration: 200.ms,
              ),
            if (icon != null) horizontalShim,
            AnimatedDefaultTextStyle(
              child: value ?? Text(placeholder ?? "", style: style),
              style: style,
              duration: 200.ms,
            )
          ],
        ),
      ),
      duration: 200.ms,
    );
  }
}
